/****************************************************************************/
/*                       24HOP 2015 - Summit Preview                        */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                     Lock Escalation (Session 1)                          */
/****************************************************************************/

use SqlServerInternals
go

set nocount on
go

DBCC SQLPERF ('sys.dm_os_wait_stats', CLEAR)
go

set transaction isolation level read uncommitted
begin tran
	update Delivery.Orders
	set OrderStatusId = 1
	where 
		OrderId in 
		(
			select top 10000 OrderId -- Change to 10000 to trigger lock escalation
			from Delivery.Orders
			order by OrderId
		)

	select * from sys.dm_tran_locks where request_session_id = @@SPID -- and resource_type <> 'KEY'
	-- Run session 2 code
rollback
go







alter table Delivery.Orders set (lock_escalation = disable)
--alter table Delivery.Orders set (lock_escalation = auto)