/****************************************************************************/
/*                  SQL Server Internals: The Practical Angle               */
/*                            PASS Summit 2015                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                          "Universal Plans"                               */
/****************************************************************************/

use SqlServerInternals
go

set nocount on
go

alter proc dbo.GetPeopleAge(
	@Country varchar(100) 
)
as
	select avg(Age)
	from dbo.People
	where 
		(@Country is null) or (Country = @Country)
go

-- Enable Actual Execution Plan
set statistics io
on

dbcc freeproccache
go

exec dbo.GetPeopleAge @Country = 'CANADA'
go

exec dbo.GetPeopleAge @Country = null
go

exec dbo.GetPeopleAge @Country = 'USA'
go



alter proc dbo.GetPeopleAge(
	@Country varchar(100) 
)
as
	select avg(Age)
	from dbo.People
	where 
		(@Country is null) or (Country = @Country)
	option (recompile)
go











alter proc dbo.GetPeopleAge(
	@Country varchar(100) 
)
as
begin
	declare
		@SQL nvarchar(max)  

	select @SQL = 
N'select avg(Age)
from dbo.People
' + case when (@Country is not null) then N'where Country=@Country' else N'' end

	print @SQL
	exec sp_executesql 
		@SQL 
		,N'@Country varchar(100)'
		,@Country = @Country
end
go
